#include "main.h"

extern unsigned pid;
extern unsigned debug;
extern shared_mem_t* smp;

void
enqueue(unsigned short node)
{
  unsigned success;
  pointer_t tail;
  log_t* plog;
  unsigned ind;
  unsigned i;

  smp->nodes[node].next.sep.ptr = NULL;
  for (success = FALSE; success == FALSE; ) {
    tail.con = smp->tail.con;
    if (debug) {
      /* for (i=(random() % 1001); i>0; i--); */
      if (smp->lock) exit(1);
      ind = fai(&smp->index);
      if (ind == LOG_SIZE) {
	faa(&smp->index, -LOG_SIZE);
      }
      plog = &smp->log[ind % LOG_SIZE];
      plog->pid = pid;
      plog->op = ENQ_TAIL_C;
      plog->old.con = tail.con;
      plog->new.con = MAKE_LONG(node, tail.sep.count+1);
    }
    success = cas(&smp->tail,
		  tail.con,
		  MAKE_LONG(node, tail.sep.count+1));
  }
  if (tail.sep.ptr != NULL) {
    if (debug) {
      /* for (i=(random() % 1001); i>0; i--); */
      if (smp->lock) exit(1);
      ind = fai(&smp->index);
      if (ind == LOG_SIZE) {
	faa(&smp->index, -LOG_SIZE);
      }
      plog = &smp->log[ind % LOG_SIZE];
      plog->pid = pid;
      plog->op = ENQ_NEXT_C;
    }
    smp->nodes[tail.sep.ptr].next.sep.ptr = node;
  } else {
    if (debug) {
      /* for (i=(random() % 1001); i>0; i--); */
      if (smp->lock) exit(1);
      ind = fai(&smp->index);
      if (ind == LOG_SIZE) {
	faa(&smp->index, -LOG_SIZE);
      }
      plog = &smp->log[ind % LOG_SIZE];
      plog->pid = pid;
      plog->op = ENQ_HEAD_C;
    }
    smp->head.sep.ptr = node;
  }
}

unsigned short
dequeue()
{
  unsigned success;
  pointer_t head;
  pointer_t tail;
  pointer_t next;
  log_t* plog;
  unsigned ind;
  unsigned i;

  for (success = FALSE; success == FALSE; ) {
    head.con = smp->head.con;
    if (head.sep.ptr == NULL) {
      for(i=0; head.sep.ptr == NULL; i++) {
	if (i == 1000000) {
	  smp->lock = 1;
	  dump_log();
	  assert(head.sep.ptr != NULL);
	}
	head.con = smp->head.con;
      }
    }
    tail.con = smp->tail.con;
    next.sep.ptr = smp->nodes[head.sep.ptr].next.sep.ptr;
    if (head.sep.ptr == tail.sep.ptr) {
      if (debug) {
	/* for (i=(random() % 1001); i>0; i--); */
        if (smp->lock) exit(1);
        ind = fai(&smp->index);
        if (ind == LOG_SIZE) {
          faa(&smp->index, -LOG_SIZE);
        }
        plog = &smp->log[ind % LOG_SIZE];
        plog->pid = pid;
        plog->op = DEQ_ONE_ITEM_TAIL_C;
        plog->old.con = tail.con;
        plog->new.con = MAKE_LONG(NULL, tail.sep.count);
      }
      success = cas(&smp->tail,
		    tail.con,
		    MAKE_LONG(NULL, tail.sep.count));
      if (success == TRUE) {
	if (debug) {
	  /* for (i=(random() % 1001); i>0; i--); */
	  if (smp->lock) exit(1);
	  ind = fai(&smp->index);
	  if (ind == LOG_SIZE) {
	    faa(&smp->index, -LOG_SIZE);
	  }
	  plog = &smp->log[ind % LOG_SIZE];
	  plog->pid = pid;
	  plog->op = DEQ_ONE_ITEM_HEAD_C;
	  plog->old.con = head.con;
	  plog->new.con = MAKE_LONG(NULL, head.sep.count+1);
	}
	cas(&smp->head,
	    head.con,
	    MAKE_LONG(NULL, head.sep.count+1));
      }
    } else {
      if (next.sep.ptr != NULL) {
	if (debug) {
	  /* for (i=(random() % 1001); i>0; i--);*/
	  if (smp->lock) exit(1);
	  ind = fai(&smp->index);
	  if (ind == LOG_SIZE) {
	    faa(&smp->index, -LOG_SIZE);
	  }
	  plog = &smp->log[ind % LOG_SIZE];
	  plog->pid = pid;
	  plog->op = DEQ_MULTI_ITEM_C;
	  plog->old.con = head.con;
	  plog->new.con = MAKE_LONG(next.sep.ptr, head.sep.count+1);
	}
	success = cas(&smp->head,
		      head.con,
		      MAKE_LONG(next.sep.ptr, head.sep.count+1));
      }
    }
  }
  smp->nodes[head.sep.ptr].next.sep.ptr = NULL;
  return head.sep.ptr;
}
