#include "main.h"
extern shared_mem_t* smp;
extern char* Fd_name;
extern unsigned debug;

void
dump_log()
{
  FILE *fdump;
  unsigned i,j;
  log_t* plog;
  
  if (debug == 0) {
    return;
  }
  fdump = fopen(Fd_name, "w");
  assert(fdump != NULL);
  for (i=smp->index, j=0; j<LOG_SIZE; i++, j++) {
    if (i == LOG_SIZE) {
      i = 0;
    }
    plog = &smp->log[i];
    fprintf(fdump, "P%d ", plog->pid);
    switch(plog->op) {
    case PRE_ENQ_C:
      fprintf(fdump, "PRE_ENQ v%d\n", plog->value);
      break;
    case POST_ENQ_C:
      fprintf(fdump, "POST_ENQ\n");
      break;
    case PRE_DEQ_C:
      fprintf(fdump, "PRE_DEQ\n");
      break;
    case POST_DEQ_C:
      fprintf(fdump, "POST_DEQ v%d\n", plog->value);
      break;
    case ENQ_TAIL_C:
      fprintf(fdump, "Enq_tail  old%d,%d new%d,%d\n",
              plog->old.sep.ptr, plog->old.sep.count,
              plog->new.sep.ptr, plog->new.sep.count);
      break;
    case ENQ_HEAD_C:
      fprintf(fdump, "Enq_head\n");
      break;
    case ENQ_NEXT_C:
      fprintf(fdump, "Enq_next\n");
      break;
    case DEQ_ONE_ITEM_TAIL_C:
      fprintf(fdump, "Deq_one_item_tail  old%d,%d new%d,%d\n",
              plog->old.sep.ptr, plog->old.sep.count,
              plog->new.sep.ptr, plog->new.sep.count);
      break;
    case DEQ_ONE_ITEM_HEAD_C:
      fprintf(fdump, "Deq_one_item_head  old%d,%d new%d,%d\n",
              plog->old.sep.ptr, plog->old.sep.count,
              plog->new.sep.ptr, plog->new.sep.count);
      break;
    case DEQ_MULTI_ITEM_C:
      fprintf(fdump, "Deq_multi_item  old%d,%d new%d,%d\n",
              plog->old.sep.ptr, plog->old.sep.count,
              plog->new.sep.ptr, plog->new.sep.count);
      break;
    default:
      assert(0);
    }
  }
  fflush(fdump);
  fclose(fdump);
}
