#define TRUE				1
#define FALSE				0
#define NULL				0

#define MAX_NODES			0xfff
#define LOG_SIZE			0x10000
#define MAKE_LONG(lo, hi)		((hi)<<16)+(lo)
#define UNLOCKED_S			0
#define LOCKED_S			1

#define PRE_ENQ_C                       0
#define POST_ENQ_C                      1
#define PRE_DEQ_C                       2
#define POST_DEQ_C                      3
#define ENQ_EMPTY_C                     4
#define ENQ_NON_EMPTY_C                 5
#define ENQ_NON_EMPTY1_C                6
#define ENQ_NON_EMPTY2_C                7
#define ENQ_ENQ1_C                      8
#define ENQ_ENQ2_C                      9
#define DEQ_ONE_ITEM_C                  10
#define DEQ_MULTI_ITEM_C                11
#define DEQ_ENQ1_C                      12
#define DEQ_ENQ2_C                      13


typedef union pointer {
  struct {
    volatile unsigned short count;
    volatile unsigned short ptr;
  } sep;
  volatile unsigned long con;
}pointer_t;

typedef struct node {
  unsigned data;
  pointer_t next;
  pointer_t status;
} node_t;

typedef struct log {
  unsigned pid;
  unsigned op;
  pointer_t anchor;
  pointer_t next;
  unsigned value;
  pointer_t old;
  pointer_t new;
} log_t;

typedef struct shared_mem {
  unsigned lock;
  pointer_t anchor;
  node_t nodes[MAX_NODES+1];
  unsigned index;
  log_t log[LOG_SIZE];
} shared_mem_t;
