#include "main.h"

extern unsigned pid;
extern unsigned iterations;
extern unsigned initial_nodes;
extern private_t private;
extern shared_mem_t* smp;


void
init_private()
{
  private.node = 2 + initial_nodes + pid;
  private.value = 2 + initial_nodes + (pid * iterations);
}

void
init_memory()
{
}

unsigned
new_node()
{
  return private.node;
}

void
reclaim(unsigned node)
{
  private.node = node;
}

void
init_queue()
{
  unsigned i;

  /* init lock */
  smp->hlock = 0;
  smp->tlock = 0;

  /* initialize empty queue */
  smp->head = 1;
  smp->tail = 1;
  smp->nodes[1].next = NULL;

  /* initialize queue contents */
  smp->tail = 1 + initial_nodes;
  for (i=2; i<initial_nodes+2; i++) {
    smp->nodes[i].value = i;
    smp->nodes[i-1].next = i;
  }
  smp->nodes[1+initial_nodes].next = NULL;
}

void
enqueue(unsigned val)
{
  unsigned node;

  node = new_node();
  /* assert(node != NULL); */
  smp->nodes[node].value = val;
  smp->nodes[node].next = NULL;
  tts_acq(&smp->tlock);
  smp->nodes[smp->tail].next = node;
  smp->tail = node;
  smp->tlock = 0;
}

unsigned
dequeue()
{
  unsigned val;
  unsigned node;
  unsigned new_head;

  tts_acq(&smp->hlock);
  node = smp->head;
  new_head = smp->nodes[node].next;
  /* assert(new_head != NULL); */
  val = smp->nodes[new_head].value;
  smp->head = new_head;
  smp->hlock = 0;
  reclaim(node);
  return val;
}
